/* belso_homero
 *
 * A belső 1,1 V-os referencia és a beépített hőmérő 
 * segítségével meghatározzuk a hőmérsékletet.
 * A beépített hőmérő a 0b1000 csatornán érhető el.
 * A konverziós képlet az ATmega328p adatlapjában
 * található. Ennek egyszerűsített formája a MiniPirate
 * kódjában látható, ami a Celsius fokokban adott
 - hőmérséklet 10 000-szeresát számolja ki.
 *
 * Források: http://www.tavir.hu/konyv-trukkok-internal
 * valamint https://github.com/chatelao/MiniPirate
 */


long readTemp() {
  long result;
  // Hőmérés , 1V1 belső referenciával
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(20);                        // Vref beállási idő
  ADCSRA |= _BV(ADSC);              // Konverzió indítása
  while (bit_is_set(ADCSRA,ADSC));  // Konverzió végére vár
  result = ADCL;                    // Előbb ezt kell kiolvasni
  result |= ADCH<<8;                // Magasabb helyiértékű bitek 
  result = (result - 125) * 1075;   // Hőmérséklet * 10 000 Celsius
  return result;
}

void setup() {
  Serial.begin(9600);
  Serial.println("Belső hőmérő");
}

void loop() {
  long temp = readTemp();
  Serial.print("Temperature = ");
  Serial.print(temp / 10000.0f,1);
  Serial.println(" ºC");
  delay(5000);
}
